local MSG = require "api_msg"
local CO = require "api_coservice"
local cjson = require "cjson"
local __flg, FEATURES = pcall( require, "features" )
if not __flg or type(FEATURES) ~= "table" then
	FEATURES = {
	}
end


local dset = {mode="encoder"}

local function API_nav(red, args)
	local nav =
	{
		main_nav= {
			{
				href= "/encoder",
				en_text= "Encoder",
				zh_text= "编码",
				mode = "encoder"
			},{
				href= "/decoder",
				en_text= "Decoder",
				zh_text= "解码",
				mode = "decoder"
			}, {
				href= "/networksetup",
				en_text= "Network",
				zh_text= "网络"
			}, {
				href= "discoveryServer",
				en_text = "Discovery Server",
				zh_text = "发现服务器"
			}
			},
			sys_nav= {{
				href= "/users",
				en_text= "Manage Users",
				zh_text= "用户管理"
			}, {
				href= "reset",
				en_text= "Reconnect",
				zh_text= "快速重连"
			}, {
				href= "reboot",
				en_text= "Reboot",
				zh_text= "设备重启"
			}, {
				href= "restore",
				en_text= "Reset Factory Settings",
				zh_text= "恢复出厂设置"
			}, {
				href= "/firmwareudp",
				en_text= "Firmware Update",
				zh_text= "固件升级"
			}}
		}

		--No decoding, so remove the decoder item.
		if FEATURES.FEATURE_NO_DECODING then
			table.remove( nav.main_nav, 2 )
		end

		MSG.OK( "", { data =nav  } )
		return true
	end


	local function API_components(red, args)
		local data=
		{{
			name= "vue",
			url= "MIT",
			software= "MIT License",
			address= "https://github.com/vuejs/vue"
		}, {
			name= "Element-UI",
			url= "MIT",
			software= "MIT License",
			address= "https://github.com/ElemeFE/element"
		}, {
			name= "OpenResty",
			url= "BSD",
			software= "BSD license",
			address= "https://github.com/openresty/openresty.org"
		}, {
			name= "luajit",
			url= "MIT",
			software= "MIT license",
			address= "http://luajit.org"
		}, {
			name= "lua",
			url= "MIT",
			software= "MIT license",
			address= "http://www.lua.org"
		}, {
			name= "nginx",
			url= "BSD2C",
			software= "BSD-2c",
			address= "http://nginx.org"
		}, {
			name= "libev",
			url= "BSD2C",
			url2= "GPL",
			software= "BSD-2c",
			software2= "GPLv2+",
			address= "http://dist.schmorp.de/libev"

		}, {
			name= "openssl",
			url= "OpenSSL",
			url2= "SSLeay",
			software= "OpenSSL",
			software2= "SSLeay",
			address= "http://www.openssl.org"
		}}

		MSG.OK( "", { data =data  } )
		return true
	end


	local function API_mode(red, args)
		local modedata =
		{mode=dset.mode}

		MSG.OK( "", { data =modedata  } )
		return true
	end


	local function API_modifyMode(red, args)
		if not args.mode then
			MSG.ERROR("Invalid submission parameters")
			return true
		end
		dset.mode = args.mode

		MSG.OK( "" )
		return true
	end



	--------------

	dset.APIS = dset.APIS or {}

	dset.APIS["nav"] = API_nav
	dset.APIS["components"] = API_components
	dset.APIS["mode"] = API_mode
	dset.APIS["modifyMode"] = API_modifyMode

	return dset



