local DC = require "supertable.declare"
local CONF = require "supertable.core"

----------------------------
local _M = {
	config_location = "/data/configs",
	config_file = "apiAuthorization.conf"
}

----------------------------

local api_template = DC.OBJ({
	APIAuthorization = DC.BOOL(true)
}) : __changed( function(conf)
	conf:TAB_SAVE()
end)

----------------------------

local failDefault = {
	APIAuthorization = true
}

-------------------------------------------------------

function _M.Load()
	local conf = CONF.Create({}, api_template)
	conf:TAB_STORAGE( "file", { file =  _M.config_location .. "/" .. _M.config_file } )
	local _, r = conf:TAB_LOAD()
	if not r then --Try load a fail-default configure 
		conf:TAB_BIND(failDefault)
	end
	conf:TAB_RESET_CHANGE()
	return conf
end

-------------------------------------------------------

return _M


