local CFG = require "supertable.core"
local DC = require "supertable.declare"

local _M = {
	config_file = "/data/configs/ptz.conf"
}
--[[
local general_set_decl = DC.OBJ {
} : __changed( function(conf)
        conf:TAB_SAVE()
end )
]]
local general_set_decl = DC.OBJ {
	enable = DC.INT(),
	typ = DC.STR(),
	network = DC.OBJ{
		protocol = DC.STR(),
		addr = DC.STR(),
		port = DC.INT(),
		ptz_protocol = DC.STR(),
		ptz_addr = DC.STR()
	},
	serial = DC.OBJ{
		device = DC.STR(),
		baudrate = DC.INT(),
		parity = DC.STR(),
		startBits = DC.INT(),
		endBits = DC.INT(),
		xonxoff = DC.INT(),
		rtscts = DC.INT()
	} 

} : __changed( function(conf)
	conf:TAB_SAVE()
end )
local failDefault = {
	enable = 1,
	typ = "network",
	network = {
		protocol = "TCP",
		addr = "",
		port = "",
		ptz_protocol = "visca",
		ptz_addr = 1
	},
	serial = {
		device = "",
		baudrate = 0,
		parity = "none",
		startBits = 5,
		endBits = 1,
		xonxoff = 0,
		rtscts = 0
	}
}



function _M.Load(file)
	local gen_set = CFG.Create( {}, general_set_decl )
	gen_set:TAB_STORAGE( "file", { file = _M.config_file } )
	local _, r = gen_set:TAB_LOAD()
	if not r then --Try load a fail-default configure 
		gen_set:TAB_BIND( failDefault )
	end
	gen_set:TAB_RESET_CHANGE()
	return gen_set
end

return _M
