local TOOLS = require "system.cmdtools"
local _dbg = require "coaf.debug"

local _M = {}

function _M.Update(location, offset)
	local targetZone = "/usr/share/zoneinfo/" .. location
	local testf = io.open( targetZone, "r" )
	if testf then
		testf:close()
	else
		local ofs = tonumber(offset)
		if ofs then
			ofs = math.floor(ofs)
			if ofs > 0 then
				ofs = "-" .. ofs
			else
				ofs = "+" .. (-ofs)
			end
		else
			ofs = "-8"
		end
		targetZone = "/usr/share/zoneinfo/Etc/GMT" .. ofs
		testf = io.open( targetZone, "r" )
		if testf then
			testf:close()
		else
			_dbg.Warn( "SYSCTRL", "Invalid timezone set of:", location, ", offset=", offset)
			targetZone = nil
		end
	end

	if targetZone then
			os.execute( "/usr/bin/test \"$(" .. TOOLS.READLINK .. " /etc/localtime)\" = \"" .. targetZone .. "\" || /bin/ln -sf \"" .. targetZone .. "\" /etc/localtime" )
	end
end

return _M

